#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mount.h>
#include <dlfcn.h>
#include "inkview.h"

int main_handler(int type, int par1, int par2);
ifont *myfont;
char kbuffer[256];
char book[256];
int cindex=1;

int myfontsize = 14;
int gap = 26;	// gap between lines
int cursor = 10;	// position 0..29
int oldcursor;
int booksa = 0;	// amount of books
int badbooksa = 0;	// amount of deleted books
int badbooks[50];	// and they are
int is_long = 0;	// sign of long key press


char lastbooksfile[] = LASTOPENBOOKS;

imenu menu1[] = {
	{ ITEM_ACTIVE, 110, "Move to top", NULL },
	{ ITEM_ACTIVE, 120, "Remove", NULL },
	{ ITEM_ACTIVE, 130, "Info", NULL },
	{ ITEM_ACTIVE, 150, "Open", NULL },
	{ ITEM_ACTIVE, 777, "Exit", NULL },
	{ ITEM_ACTIVE, 140, "Remove deleted books", NULL },
	{ 0, 0, NULL, NULL }
};
int remove_deleted_books_index = 5;	// don't forget to change it if menu1 was changed!


void MoveCursor(int shift) {	
	if ((booksa - badbooksa) > 1) {
		oldcursor = cursor;
		cursor = cursor + shift;
		if (cursor < 0) cursor = cursor + booksa;
		if (cursor >= booksa) cursor = cursor - booksa;
		while (badbooks[cursor] == 1) { 
			if (shift < 0) cursor--; else cursor++;
			if (cursor < 0) cursor = cursor + booksa;
			if (cursor >= booksa) cursor = cursor - booksa;
		}
		if (shift != 0) InvertAreaBW(0, 10+oldcursor*gap, ScreenWidth(), 19);
	}
	InvertAreaBW(0, 10+cursor*gap, ScreenWidth(), 19);
	SoftUpdate();
}


void mainscreen_repaint() {
	ClearScreen();
	SetFont(myfont, BLACK);
	FILE *fff = iv_fopen(lastbooksfile, "rt");
	FILE *filetmp;
	char sss[256];
	char ss2[256];
	int i = 0;
	int topten = 0;
	badbooksa = 0;
	booksa = 0;
	for (i=0; i<30; i++) badbooks[i] = 0;
	while( !feof(fff) ) {
		fgets(sss, 256, fff);
		if (!feof(fff)) sss[strlen(sss)-1] = '\0'; else break;
		filetmp = iv_fopen(sss, "rt");
		if (filetmp){
			iv_fclose(filetmp);
			SetFont(myfont, BLACK);
			DrawString(15, 10+booksa*gap, GetBookInfo(sss)->title);
		}else{ 
			badbooksa++;
			badbooks[booksa] = 1;
			for (i=10; i<256; i++) ss2[i-10] = sss[i];
			SetFont(myfont, LGRAY);
			DrawString(15, 10+booksa*gap, ss2);
		}
		booksa++;
		if ((booksa - badbooksa) == 10 && topten == 0) {
			topten = booksa - 1;
			DrawRect(0, booksa*gap + 5, ScreenWidth(), 2, BLACK);
		}
	}
	fclose(fff);
	if (badbooksa == 0) menu1[remove_deleted_books_index].type = 0;
	sprintf(kbuffer, "%i", GetTemperature()); DrawString(ScreenWidth()-24, ScreenHeight()-20, kbuffer);
	MoveCursor(0);
}



// int type: 0 - to top; 1 - remove; 2 - remove all deleted
void BookChange(int page, int type) {
	FILE *ffw = fopen(TEMPDIR "/lastopen.tmp", "w+");
	FILE *fff = iv_fopen(lastbooksfile, "rt");
	char sss [256];
	int iii = 0;
	if (type == 0) while( !feof(fff) ) {
		fgets(sss, 256, fff);
		if (iii == page) fputs(sss, ffw);
		iii++;
	}
	rewind(fff);
	iii = 0;
	while( !feof(fff) ) {
		fgets(sss, 256, fff);
		if (feof(fff)) break;
		if ((type == 2) && (badbooks[iii] == 1)) { iii++; continue; }
		if ((type == 2) || (iii != page)) fputs(sss, ffw);
		iii++;
	}
	fclose(fff);
	FILE *ffn = fopen(lastbooksfile, "w+");
	rewind(ffw);
	while( !feof(ffw) ) {
		fgets(sss, 256, ffw);
		if (feof(ffw)) break;
		fputs(sss, ffn);
	}
	fclose(ffn); 
	fclose(ffw); 
	mainscreen_repaint();
}

//      ,     
void GetBook(int i){
	FILE *fff = iv_fopen(lastbooksfile, "rt");
	int iii = 0;
	while( !feof(fff) ) {
		fgets(book, 256, fff);
		if (iii == i) { 
			if (!feof(fff)) book[strlen(book)-1] = '\0'; else break;
			fclose(fff);
			return;
		}
		iii++;
	}
	fclose(fff); 
	return;
}

void ShowInfo(int i){
	char ss2[256];
	char *ss3;
	GetBook(i);
	ss3 = GetBookInfo(book)->path;
	for (i=10; i<256; i++) ss2[i-10] = ss3[i];
	sprintf(kbuffer, "%s\n%i", ss2, GetTemperature());
	Message(ICON_INFORMATION, GetBookInfo(book)->typedesc, kbuffer, 5000); 
}





void menu1_handler(int index) {
	cindex = index;
	switch (index) {
		case 110:
			BookChange(cursor, 0);
			break;

		case 120:
			BookChange(cursor, 1);
			break;

		case 130: 
			ShowInfo(cursor);
			break;

		case 140:
			BookChange(cursor, 2);
			break;

		case 150:
			ShowHourglass();
			GetBook(cursor);
			OpenBook(book, NULL, 0);
			break;

		case 777:
			CloseApp();
			break;
	}
}

int main_handler(int type, int par1, int par2) {
 
	if (type == EVT_INIT) {	// occurs once at startup, only in main handler
		if (GetOrientation() != 0 && GetOrientation() != 3) SetOrientation(0);
		gap = ScreenHeight() / 30;
		myfontsize = ScreenHeight() / 57;
		myfont = OpenFont("LiberationSans", myfontsize, 0);
	}

	if (type == EVT_SHOW) {	// occurs when this event handler becomes active
		mainscreen_repaint();
	}

	if (type == EVT_POINTERDOWN) { 	//CalibrateTouchpanel();
		oldcursor = ((par2 * 30) / ScreenHeight()) - cursor;
		MoveCursor(oldcursor);
		OpenMenu(menu1, cindex, par1, par2, menu1_handler);
	}

	if (type == EVT_KEYREPEAT) { switch (par1) {
			case KEY_LEFT: MoveCursor(-5); break;
			case KEY_RIGHT: MoveCursor(5); break;
			case KEY_UP: MoveCursor(-1); break;
			case KEY_DOWN: MoveCursor(1); break;
			case KEY_OK: 
				is_long = 1;
				OpenMenu(menu1, cindex, 200, cursor*gap + 15, menu1_handler);
				break;
	} }

	if (type == EVT_KEYUP) { switch (par1) {
			case KEY_OK:
				if (is_long == 0) {
					ShowHourglass();
					GetBook(cursor);
					OpenBook(book, NULL, 0);
				}
				is_long = 0;
				break;
	} }
	
	if (type == EVT_KEYPRESS) {
		switch (par1) {

			case KEY_PLUS:
				BookChange(cursor, 0);
				break;

			case KEY_MINUS:
				BookChange(cursor, 1);
				break;

			case KEY_LEFT:
				MoveCursor(-5);
				break;

			case KEY_RIGHT:
				MoveCursor(5);
				break;

			case KEY_UP:
				MoveCursor(-1);
				break;

			case KEY_DOWN:
				MoveCursor(1);
				break;

			case KEY_MUSIC:
				break;

			case KEY_MENU:
				break;

			case KEY_BACK:
				CloseApp();
				break;

			case KEY_DELETE:	
				ShowInfo(cursor);
				break;
		}
	}

	if (type == EVT_EXIT) {
		// occurs only in main handler when exiting or when SIGINT received - save configuration here, if needed
	}
	return 0;
}



int main(int argc, char **argv) {
	InkViewMain(main_handler);
	return 0;
}

